import 'dart:async';

import 'package:apple_push_notification_service/notification_method_channel.dart';
import 'package:flutter/services.dart';

class ApplePushNotificationService {
  static Future<void> init({
    OnSelectNotificationCallback onSelectNotificationCallback,
    OnRegisterNotificationCallback onRegisterNotificationCallback,
  }) async {
    const methodChannel = MethodChannel(NotificationMethodChannel.mainChannel);

    methodChannel.setMethodCallHandler((MethodCall call) async {
      switch (call.method) {
        case NotificationMethodCall.didRegisterForRemoteNotificationsWithDeviceToken:
          onRegisterNotificationCallback.call(call.arguments);
          break;
        case NotificationMethodCall.didSelectNotification:
          final payload = Map<String, dynamic>.from(call.arguments);
          onSelectNotificationCallback.call(payload);
          break;
      }
    });

    await methodChannel.invokeMethod(NotificationMethodCall.didInitMainChannel);
  }
}
